import numpy as np

def pca(X):
    """
    固有値問題を用いて主成分分析を実行します．

    パラメータ
    ----------
    X: データ行列

    戻り値
    -------
    P: ローディング行列
    t: 主成分得点行列
    """

    # 共分散行列を計算します
    V = np.cov(X.T)
    # 共分散行列の固有値問題を解きます
    _, P = np.linalg.eig(V)

    # 主成分得点を計算します
    t = X @ P
    return P, t